commit af569192112c0abe1078fc976183264294a67bc9
Author: freddy77 <freddy77>
Date:   Fri Jul 23 07:42:25 2010 +0000

    use ird to get column count

diff --git a/ChangeLog b/ChangeLog
index b3ea9ef..75ae0bf 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Fri Jul 23 09:42:11 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/prepare_results.c: use ird to get column count
+
 Thu Jul 22 16:23:52 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc.c src/odbc/unittests/cursor2.c: fix cursor2 issue
 
@@ -2735,4 +2738,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3087 2010/07/22 14:24:14 freddy77 Exp $
+$Id: ChangeLog,v 1.3088 2010/07/23 07:42:25 freddy77 Exp $
diff --git a/src/odbc/unittests/prepare_results.c b/src/odbc/unittests/prepare_results.c
index cd18246..888b569 100644
--- a/src/odbc/unittests/prepare_results.c
+++ b/src/odbc/unittests/prepare_results.c
@@ -2,39 +2,35 @@
 
 /* Test for data format returned from SQLPrepare */
 
-static char software_version[] = "$Id: prepare_results.c,v 1.12 2010/07/05 09:20:33 freddy77 Exp $";
+static char software_version[] = "$Id: prepare_results.c,v 1.13 2010/07/23 07:42:25 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-int
-main(int argc, char *argv[])
+static void
+Test(int use_ird)
 {
 	SQLSMALLINT count, namelen, type, digits, nullable;
 	SQLULEN size;
+	SQLHDESC desc;
+	SQLINTEGER ind;
 	char name[128];
 
-	odbc_connect();
-
-	odbc_command("create table #odbctestdata (i int, c char(20), n numeric(34,12) )");
-
-	/* reset state */
-	odbc_command("select * from #odbctestdata");
-	SQLFetch(odbc_stmt);
-	SQLMoreResults(odbc_stmt);
-
-	/* test query returns column information for update */
-	CHKPrepare((SQLCHAR *) "update #odbctestdata set i = 20", SQL_NTS, "S");
-
-	CHKNumResultCols(&count, "S");
+	/* test query returns column information */
+	CHKPrepare((SQLCHAR *) "select * from #odbctestdata select * from #odbctestdata", SQL_NTS, "S");
 
+	SQLNumParams(odbc_stmt, &count);
 	if (count != 0) {
-		fprintf(stderr, "Wrong number of columns returned. Got %d expected 0\n", (int) count);
+		fprintf(stderr, "Wrong number of params returned. Got %d expected 0\n", (int) count);
 		exit(1);
 	}
 
-	/* test query returns column information */
-	CHKPrepare((SQLCHAR *) "select * from #odbctestdata select * from #odbctestdata", SQL_NTS, "S");
+	if (use_ird) {
+		/* get IRD */
+		CHKGetStmtAttr(SQL_ATTR_IMP_ROW_DESC, &desc, sizeof(desc), &ind, "S");
 
-	CHKNumResultCols(&count, "S");
+		CHKR(SQLGetDescField, (desc, 0, SQL_DESC_COUNT, &count, sizeof(count), &ind), "S");
+	} else {
+		CHKNumResultCols(&count, "S");
+	}
 
 	if (count != 3) {
 		fprintf(stderr, "Wrong number of columns returned. Got %d expected 3\n", (int) count);
@@ -61,6 +57,35 @@ main(int argc, char *argv[])
 		fprintf(stderr, "wrong column 3 informations (type %d name '%s' size %d)\n", (int) type, name, (int) size);
 		exit(1);
 	}
+}
+
+int
+main(int argc, char *argv[])
+{
+	SQLSMALLINT count;
+
+	odbc_connect();
+
+	odbc_command("create table #odbctestdata (i int, c char(20), n numeric(34,12) )");
+
+	/* reset state */
+	odbc_command("select * from #odbctestdata");
+	SQLFetch(odbc_stmt);
+	SQLMoreResults(odbc_stmt);
+
+	/* test query returns column information for update */
+	CHKPrepare((SQLCHAR *) "update #odbctestdata set i = 20", SQL_NTS, "S");
+
+	CHKNumResultCols(&count, "S");
+
+	if (count != 0) {
+		fprintf(stderr, "Wrong number of columns returned. Got %d expected 0\n", (int) count);
+		exit(1);
+	}
+
+	Test(0);
+	odbc_reset_statement();
+	Test(1);
 
 	/* TODO test SQLDescribeParam (when implemented) */
 	odbc_command("drop table #odbctestdata");

